/***************************************************************************
                          simfold.h  -  description
                             -------------------
    begin                : Thu Apr 11 2002
    copyright            : (C) 2002 by Mirela Andronescu
    email                : andrones@cs.ubc.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef SIMFOLD_H
#define SIMFOLD_H

#include "init.h"

double simfold (char *sequence, char *structure);
// PRE:  the init_data function has been called;
//       the space for structure has been allocated
// POST: fold sequence, return the MFE structure in structure, and return the MFE


double free_energy_simfold (char *sequence, char *structure);
// PRE:  sequence and structure are given as input
// !!! structure should not be sth like "...(((..)))", but a variable!!!
// POST: returns the free energy of sequence folded into structure
//       Worst case complexity = n^2 (n = length of sequence)
// (the function is implemented in s_specific_functions.cpp)


double enthalpy_simfold (char *sequence, char *structure);
// PRE:  sequence and structure are given as input
// POST: returns the enthalpy of sequence folded into structure
//       Worst case complexity = n^2 (n = length of sequence)


#endif
